#!/usr/bin/perl
#
# CalendarMaker - makes your original calendar
#
# CalenderMaker Copyright (c) 2000 Sakai Hiroaki.
# All Rights Reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; see the file COPYING.  If not, write to
# the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

require "timelocal.pl";

$width = 550;
$height = 720;
$margin = 50;
$picture_height = 300;
$spacer1 = 50;
$spacer2 = 20;
$number_space_width = 70;
$number_space_height = 40;
$holiday_space_height = 30;

@month_name = ("January", "February", "March", "April",
		"May", "June", "July", "August",
		"September", "October", "November", "December");
@week_name = ("Sun.", "Mon.", "Tue.", "Wed.", "Thu.", "Fri.", "Sut.");
@week_color = ("red", "black", "black", "black", "black", "black", "blue");

%holiday = (
	"1/1",		"",
	"1/2",		"<br>",
	"1/3",		"<br>",
	"1/2Mon.",	"ͤ",
	"2/11",		"ǰ",
	"4/29",		"ߤɤ",
	"5/3",		"ˡǰ",
	"5/4",		"̱ε",
	"5/5",		"ɤ",
	"7/20",		"",
	"9/15",		"Ϸ",
	"10/10",	"ΰ",
	"11/3",		"ʸ",
	"11/23",	"ϫդ",
	"12/23",	"ŷ",
);

%eventday = (
	"1/7",		"",
	"2/3",		"ʬ",
	"2/14",		"Х󥿥<br>ǡ",
	"3/3",		"Ҥʺפ",
	"3/14",		"ۥ磻ȥǡ",
	"4/1",		"ץ<br>ա",
	"5/2Sun.",	"",
	"6/3Sun.",	"",
	"7/7",		"ͼ",
	"8/15",		"ﵭǰ",
	"12/25",	"ꥹޥ",
	"12/31",	"糢",
);

($tmp, $tmp, $tmp, $tmp, $now_month, $now_year) = localtime(time);
$now_month++;
$now_year += 1900;

$text_digit = 0;
$output_filename = "calendar";
$holiday_filename = "holiday";
$mkcalendar_dir = "MKCALENDAR_DIR";

while ($_ = shift(@ARGV)) {
	if      ($_ eq "-year"  ) {
		$year = shift @ARGV;
	} elsif ($_ eq "-month" ) {
		$month = shift @ARGV;
	} elsif ($_ eq "-o"     ) {
		$output_filename = shift @ARGV;
	} elsif ($_ eq "-output") {
		$output_filename = shift @ARGV;
	} elsif ($_ eq "-f"     ) {
		$holiday_filename = shift @ARGV;
	} elsif ($_ eq "-file"  ) {
		$holiday_filename = shift @ARGV;
	} elsif ($_ eq "-text"  ) {
		$text_digit = 1;
	} else {
		@pictures = (@pictures, $_);
	}
}

if ($year eq "") {
	$year = $now_year;
}

if ($month eq "") {
	$start_month =  1;
	$end_month   = 12;
} else {
	$start_month = $month;
	$end_month   = $month;
}

if ($holiday_filename ne "") {
	open(FILE, "< $holiday_filename") || die "$holiday_filename is not found.\n";
	while (<FILE>) {
		($day, $name, $holiday) = split;
		if ($day =~ /^\#/) { next; }
		if ($holiday =~ /holiday/i) {
			$holiday{"$day"} = "$holiday{$day}<br>$name";
		} else {
			$eventday{"$day"} = "$eventday{$day}<br>$name";
		}
	}
	close(FILE);
}

for ($month = $start_month; $month <= $end_month; $month++) {

	# x
	($tmp, $tmp, $tmp, $tmp, $tmp, $tmp, $start_week, $yday) =
		 localtime(timelocal(0, 0, 0, 1, $month - 1, $year - 1900));

	# xϲޤǤΤ׻(뤦ǯθƤ)
	if ($month == 12) {
		$lastday = 31;
	} else {
		($tmp, $tmp, $tmp, $tmp, $tmp, $tmp, $tmp, $next_yday) =
			 localtime(timelocal(0, 0, 0, 1, $month, $year - 1900));
		$lastday = $next_yday - $yday;
	}

	$picture = shift (@pictures);

	open (FILE, "> $output_filename$month.html");

	print FILE "<html>\n";
	print FILE "<head>\n";
	print FILE "<title>$year\'s Calendar</title>\n";
	print FILE "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n";
	print FILE "</head>\n";
	print FILE "<body bgcolor=white width=$width height=$height>\n";
	print FILE "<spacer type=vertical size=$margin>\n";
	print FILE "<center>\n";
	print FILE "<img src=\"$picture\" height=$picture_height>\n";
	print FILE "</center>\n";
	print FILE "<spacer type=vertical size=$spacer1>\n";
	print FILE "<center>\n";
	print FILE "<h2>$year $month_name[$month-1]</h2>\n";
	print FILE "</center>\n";
	print FILE "<spacer type=vertical size=$spacer2>\n";
	print FILE "<center>\n";
	print FILE "<table>\n";
	print FILE "<tr>\n";
	print FILE "<td align=center>Sun.</td>\n";
	print FILE "<td align=center>Mon.</td>\n";
	print FILE "<td align=center>Tue.</td>\n";
	print FILE "<td align=center>Wed.</td>\n";
	print FILE "<td align=center>Thu.</td>\n";
	print FILE "<td align=center>Fri.</td>\n";
	print FILE "<td align=center>Sut.</td>\n";
	print FILE "</tr>\n";

	$day = 1 - $start_week;
	while ($day <= $lastday) {
		print FILE "<tr>\n";
		$holiday_space = "";
		$exchange_holiday = 0; # صե饰
		for ($week = 0; $week < 7; $week++) {
			print FILE "<td align=center width=$number_space_width height=$number_space_height>";
			if (($day < 1) || ($day > $lastday)) {
				$holiday_space = "$holiday_space<td align=center height=$holiday_space_height></td>\n";
				print FILE "</td>\n";
				$day++;
				next;
			}

			# 貿ܤ׻
			$week_count = (($day - 1) - (($day - 1) % 7)) / 7 + 1;

			$n = $week_name[$week];

			# ȥ٥Ȥν
			# $h2, $e2 ˤϡ裳פʤɤξ
			$h1 = $holiday{"$month\/$day"};
			$h2 = $holiday{"$month\/$week_count$n"};
			$h = "$h1<br>$h2";

			$e1 = $eventday{"$month\/$day"};
			$e2 = $eventday{"$month\/$week_count$n"};
			$e = "$e1<br>$e2";

			$event_and_holiday = "";

			if (($h1 ne "") || ($h2 ne "")) { # ξ
				$wc = "red";
				$event_and_holiday = "$h";
				# صν
				if ($week == 0) { $exchange_holiday = 1; }
				else            { $exchange_holiday = 0; }
			} elsif ($exchange_holiday == 1) { # صξ
				$wc = "red";
				$event_and_holiday = "ص";
				$exchange_holiday = 0;
			} else {
				$wc = $week_color[$week];
			}

			$event_and_holiday = "$event_and_holiday<br>$e";

			while ($event_and_holiday =~ /\<br\>\<br\>/i) {
				$event_and_holiday =~ s/\<br\>\<br\>/\<br\>/i;
			}
			while ($event_and_holiday =~ /^\<br\>/i) {
				$event_and_holiday =~ s/^\<br\>//i;
			}
			while ($event_and_holiday =~ /\<br\>$/i) {
				$event_and_holiday =~ s/\<br\>$//i;
			}

			# ν
			if ($text_digit == 1) {
				print FILE "$day";
			} else {
				$d1 = $day % 10;
				$d10 = ($day - $d1) / 10;
				if ($d10 > 0) {
					print FILE "<img src=\"fonts/font$d10\_$wc.png\">";
				}
				print FILE "<img src=\"fonts/font$d1\_$wc.png\">";
			}

			$holiday_space = "$holiday_space<td align=center height=$holiday_space_height>$event_and_holiday</td>\n";
			print FILE "</td>\n";
			$day++;
		}
		print FILE "</tr>\n";
		print FILE "<tr>\n";
		print FILE "$holiday_space";
		print FILE "</tr>\n";
	}

	print FILE "</table>\n";
	print FILE "</center>\n";

#	if ($month > 1) {
#		$prev = $month - 1;
#		print FILE "<a href=\"$output_filename$prev.html\">$prev</a>\n";
#	}
#	if ($month < 12) {
#		$next = $month + 1;
#		print FILE "<a href=\"$output_filename$next.html\">$next</a>\n";
#	}

	print FILE "</body>\n";
	print FILE "</html>\n";

	close (FILE);

	@pictures = (@pictures, $picture);
}

# End of Program.
